<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CruiseFlight ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CruiseFlight extends AbstractStructArrayBase
{
    /**
     * The Flight
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CruiseFlight[]
     */
    public $Flight;
    /**
     * Constructor method for ArrayOfJP_CruiseFlight
     * @uses ArrayOfJP_CruiseFlight::setFlight()
     * @param \StructType\JP_CruiseFlight[] $flight
     */
    public function __construct(array $flight = array())
    {
        $this
            ->setFlight($flight);
    }
    /**
     * Get Flight value
     * @return \StructType\JP_CruiseFlight[]|null
     */
    public function getFlight()
    {
        return $this->Flight;
    }
    /**
     * Set Flight value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseFlight[] $flight
     * @return \ArrayType\ArrayOfJP_CruiseFlight
     */
    public function setFlight(array $flight = array())
    {
        foreach ($flight as $arrayOfJP_CruiseFlightFlightItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CruiseFlightFlightItem instanceof \StructType\JP_CruiseFlight) {
                throw new \InvalidArgumentException(sprintf('The Flight property can only contain items of \StructType\JP_CruiseFlight, "%s" given', is_object($arrayOfJP_CruiseFlightFlightItem) ? get_class($arrayOfJP_CruiseFlightFlightItem) : gettype($arrayOfJP_CruiseFlightFlightItem)), __LINE__);
            }
        }
        $this->Flight = $flight;
        return $this;
    }
    /**
     * Add item to Flight value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseFlight $item
     * @return \ArrayType\ArrayOfJP_CruiseFlight
     */
    public function addToFlight(\StructType\JP_CruiseFlight $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CruiseFlight) {
            throw new \InvalidArgumentException(sprintf('The Flight property can only contain items of \StructType\JP_CruiseFlight, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Flight[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CruiseFlight|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CruiseFlight|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CruiseFlight|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CruiseFlight|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CruiseFlight|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Flight
     */
    public function getAttributeName()
    {
        return 'Flight';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_CruiseFlight
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
